diff --git a/philosophy/words-to-avoid.pt-br.po b/philosophy/words-to-avoid.pt-br.po
index 4154e98..d5f4678 100644
--- a/philosophy/words-to-avoid.pt-br.po
+++ b/philosophy/words-to-avoid.pt-br.po
@@ -10,7 +10,7 @@ msgid ""
 msgstr ""
 "Project-Id-Version: words-to-avoid.html\n"
 "POT-Creation-Date: 2017-08-01 04:26+0000\n"
-"PO-Revision-Date: 2017-05-20 16:20-0300\n"
+"PO-Revision-Date: 2017-09-05 00:54-0300\n"
 "Last-Translator: Rafael Fontenelle <rafaelff@gnome.org>\n"
 "Language-Team: Brazilian Portuguese <www-pt-br-general@gnu.org>\n"
 "Language: pt_BR\n"
@@ -19,6 +19,7 @@ msgstr ""
 "Content-Transfer-Encoding: 8bit\n"
 "Plural-Forms: nplurals=2; plural=(n > 1);\n"
 "X-Generator: Virtaal 1.0.0-beta1\n"
+"X-Outdated-Since: 2017-08-01 04:26+0000\n"
 
 #. type: Content of: <title>
 msgid ""
@@ -250,12 +251,8 @@ msgstr "“<a href=\"#PowerPoint\">PowerPoint</a>” |"
 
 #.  GNUN-SORT-NEXT-ITEM 
 #. type: Content of: <p>
-# | &ldquo;<a [-href=\"#Protection\">Protection</a>&rdquo;-]
-# | {+href=\"#Product\">Product</a>&rdquo;+} |
-#, fuzzy
-#| msgid "&ldquo;<a href=\"#Protection\">Protection</a>&rdquo; |"
 msgid "&ldquo;<a href=\"#Product\">Product</a>&rdquo; |"
-msgstr "“<a href=\"#Protection\">Proteção</a>” |"
+msgstr "“<a href=\"#Product\">Produto</a>” |"
 
 #.  GNUN-SORT-NEXT-ITEM 
 #. type: Content of: <p>
@@ -418,6 +415,10 @@ msgid ""
 "<b>with free software, the users have control of what the program does for "
 "them</b>."
 msgstr ""
+"Em vez de <b>com software livre, o público possui acesso ao programa</b>, "
+"nós dizemos <b>com sofware livre, os usuários têm as liberdades essenciais</"
+"b> e <b>com software livre, os usuários possuem controle do que o programa "
+"faz por eles</b>."
 
 #. type: Content of: <h3>
 msgid "&ldquo;Alternative&rdquo;"
@@ -1339,6 +1340,8 @@ msgid ""
 "Instead of <b>FOSS</b>, we say, <b>free software</b> or <b>free (libre) "
 "software</b>."
 msgstr ""
+"Em vez de <b>FOSS</b>, nós dizemos <b>software livre</b> ou <b>software "
+"libre</b>."
 
 #. type: Content of: <h3>
 msgid "&ldquo;Freely available&rdquo;"
@@ -1657,25 +1660,6 @@ msgstr "“MP3 Player”"
 
 #.  The MP3 patents will reportedly expire by 2018.  
 #. type: Content of: <p>
-# | In the late 1990s it became feasible to make portable, solid-state digital
-# | audio players. Most [-support-] {+supported+} the patented MP3 codec, but
-# | not all.  Some {+players+} support the patent-free audio codecs Ogg Vorbis
-# | and FLAC, and may not even support MP3-encoded files at all, precisely to
-# | avoid these patents.  To call such players &ldquo;MP3 players&rdquo; is
-# | not only confusing, it also privileges the MP3 {+format+} that we ought to
-# | reject.  We suggest the terms &ldquo;digital audio player,&rdquo; or
-# | simply &ldquo;audio player&rdquo; [-if context permits.-] {+when that's
-# | clear enough.+}
-#, fuzzy
-#| msgid ""
-#| "In the late 1990s it became feasible to make portable, solid-state "
-#| "digital audio players. Most support the patented MP3 codec, but not all.  "
-#| "Some support the patent-free audio codecs Ogg Vorbis and FLAC, and may "
-#| "not even support MP3-encoded files at all, precisely to avoid these "
-#| "patents.  To call such players &ldquo;MP3 players&rdquo; is not only "
-#| "confusing, it also privileges the MP3 that we ought to reject.  We "
-#| "suggest the terms &ldquo;digital audio player,&rdquo; or simply &ldquo;"
-#| "audio player&rdquo; if context permits."
 msgid ""
 "In the late 1990s it became feasible to make portable, solid-state digital "
 "audio players. Most supported the patented MP3 codec, but not all.  Some "
@@ -1686,15 +1670,15 @@ msgid ""
 "suggest the terms &ldquo;digital audio player,&rdquo; or simply &ldquo;audio "
 "player&rdquo; when that's clear enough."
 msgstr ""
-"No fim dos anos 90, tornou-se possível criar tocadores de audio digital com "
+"No fim dos anos 90, tornou-se possível criar tocadores de áudio digital com "
 "memória em estado sólido. A maior parte tinha suporte ao MP3, um codec "
-"patenteado, mas nem todos. Alguns tinham suporte a codecs livres de "
-"patentes, como o Ogg Vorbis e o FLAC, e outros nem mesmo tinham suporte a "
+"patenteado, mas nem todos. Alguns tocadores tinham suporte a codecs livres "
+"de patentes, como o Ogg Vorbis e o FLAC, e outros nem mesmo tinham suporte a "
 "arquivos codificados em MP3, justamente para evitar aquelas patentes. Chamar "
 "esses tocadores de “MP3 players” (ou “tocadores de MP3”) não é apenas "
-"confuso, mas também privilegia o MP3, que devemos rejeitar. Sugerimos os "
-"termos “tocador de audio digital” ou simplesmente “tocador de áudio”, se o "
-"contexto permitir."
+"confuso, mas também privilegia o formato MP3, que devemos rejeitar. "
+"Sugerimos os termos “tocador de áudio digital” ou simplesmente “tocador de "
+"áudio” quando estiver suficientemente claro."
 
 #. type: Content of: <h3>
 msgid "&ldquo;Open&rdquo;"
@@ -1732,6 +1716,8 @@ msgid ""
 "Instead of <b>open source</b>, we say, <b>free software</b> or <b>free "
 "(libre) software</b>."
 msgstr ""
+"Em vez de <b>código aberto</b>, nós dizemos <b>software livre</b> ou "
+"<b>software libre</b>."
 
 #. type: Content of: <h3>
 msgid "&ldquo;PC&rdquo;"
@@ -1829,20 +1815,6 @@ msgid "&ldquo;PowerPoint&rdquo;"
 msgstr "“PowerPoint”"
 
 #. type: Content of: <p>
-# | Please avoid using the term &ldquo;PowerPoint&rdquo; to mean any kind of
-# | slide presentation.  &ldquo;PowerPoint&rdquo; is just the name of one
-# | particular proprietary program to make presentations.  For your freedom's
-# | sake, you should use only free software to make your [-presentations.-]
-# | {+presentations&mdash;which means, <em>not PowerPoint</em>.+}  Recommended
-# | options include TeX's <tt>beamer</tt> class and LibreOffice.org's Impress.
-#, fuzzy
-#| msgid ""
-#| "Please avoid using the term &ldquo;PowerPoint&rdquo; to mean any kind of "
-#| "slide presentation.  &ldquo;PowerPoint&rdquo; is just the name of one "
-#| "particular proprietary program to make presentations.  For your freedom's "
-#| "sake, you should use only free software to make your presentations.  "
-#| "Recommended options include TeX's <tt>beamer</tt> class and LibreOffice."
-#| "org's Impress."
 msgid ""
 "Please avoid using the term &ldquo;PowerPoint&rdquo; to mean any kind of "
 "slide presentation.  &ldquo;PowerPoint&rdquo; is just the name of one "
@@ -1855,15 +1827,13 @@ msgstr ""
 "apresentação de slides. “PowerPoint” é apenas o nome de um programa "
 "proprietário para fazer apresentações específico. Para o bem de sua "
 "liberdade, você deve usar apenas software livre para fazer suas "
-"apresentações. Opções recomendadas incluem a classe <tt>beamer</tt> do TeX e "
-"o Impress, do LibreOffice.org."
+"apresentações &mdash; o que significa <em>não PowerPoint</em>. Opções "
+"recomendadas incluem a classe <tt>beamer</tt> do TeX e o Impress, do "
+"LibreOffice.org."
 
 #. type: Content of: <h3>
-# | [-&ldquo;Protection&rdquo;-]{+&ldquo;Product&rdquo;+}
-#, fuzzy
-#| msgid "&ldquo;Protection&rdquo;"
 msgid "&ldquo;Product&rdquo;"
-msgstr "“Proteção”"
+msgstr "“Produto”"
 
 #. type: Content of: <p>
 msgid ""
@@ -1874,6 +1844,11 @@ msgid ""
 "package deal a &ldquo;product,&rdquo; please firmly insist on calling it a "
 "&ldquo;deal.&rdquo;"
 msgstr ""
+"Se você está falando sobre um produto, por favor chame-o assim. Porém, ao se "
+"referir a um serviço, por favor não chame-o de um “produto”. Se um provedor "
+"de serviço chama o serviço de um “produto”, por favor insista em chamá-lo de "
+"um “serviço”. Se um provedor de serviço chama uma oferta de “produto”, por "
+"favor insista firmemente em chamá-la de uma “oferta”."
 
 #. type: Content of: <h3>
 msgid "&ldquo;Protection&rdquo;"
@@ -1901,8 +1876,8 @@ msgid ""
 "&rdquo;"
 msgstr ""
 "É fácil de evitar o termo “proteção” e usar termos neutros. Por exemplo, ao "
-"invés de “A proteção do copyright dura muito tempo” você pode dizer, “O "
-"copyright dura muito tempo.” "
+"invés de “A proteção do copyright dura muito tempo” você pode dizer “O "
+"copyright dura muito tempo”."
 
 #. type: Content of: <p>
 msgid ""