--- libxnee/src/xnee_error.c.orig	2014-05-06 02:15:37.000000000 -0500
+++ libxnee/src/xnee_error.c	2023-03-08 01:41:44.000000000 -0600
@@ -47,7 +47,7 @@
     "This is probably because you are out of memory",
 
     /* XNEE_FILE_NOT_FOUND */ 
-    "Xnee can't find or create the file you are lookig for ",
+    "Xnee can't find or create the file you are looking for",
     "Check the path and the permissions",
 
     /* XNEE_TIMED_OUT */      
@@ -63,19 +63,19 @@
     "For more information on this error, please read the manual(s)",
 
     /* XNEE_WRONG_PARAMS */   
-    "Wrong paramters",
-    "You have given invalid input to Xnee ",
+    "Wrong parameters",
+    "You have given invalid input to Xnee",
 
     /* XNEE_NO_REC_EXT */     
-    "Record extension missing on the display. Please add appropriate option to your X Server configuration",
+    "Record extension missing on the display. Please add appropriate option to your X server configuration",
     "Enable the RECORD extension. Read the manual on how to do this",
 
     /* XNEE_NO_TEST_EXT */    
     "XTest extension missing on the display",
-    "Enable the XTest extension. Read the mnual on how to do this",
+    "Enable the XTest extension. Read the manual on how to do this",
 
     /* XNEE_NO_PROT_CHOOSEN */
-    "No protocol choosen",
+    "No protocol chosen",
     "Make sure you have set the Xnee application to record some data",
 
     /* XNEE_NOT_OPEN_DISPLAY */
@@ -84,8 +84,8 @@
     "have permissions to open it",
 
     /* XNEE_AMBIGOUS_CMD */   
-    "Ambigious command",
-    "Make sure that the command/actions set aren't ambigous",
+    "Ambiguous command",
+    "Make sure that the command/actions set aren't ambiguous",
 
     /* XNEE_OUT_OF_SYNC */    
     "Can't synchronise any longer",
@@ -97,7 +97,7 @@
 
     /* XNEE_NO_PLUGIN_FILE */ 
     "Xnee can't find the plugin file",
-    "Make sure that the path and permission are correct",
+    "Make sure that the path and permissions are correct",
 
     /* XNEE_PLUGIN_FILE_ERROR */
     "Xnee can't use the plugin file",
@@ -110,20 +110,20 @@
     /* XNEE_NO_MAIN_DATA */   
     "xnee_data structure missing",
     "This is a major error, please report the error "
-    "with all the information you have: project file, session file, comand"
-    "line options etc",
+    "with all the information you have: project file, session file, command "
+    "line options, etc.",
 
     /* XNEE_NO_RECORD_DATA */   
     "record_setup structure missing",
     "This is a major error, please report the error "
-    "with all the information you have: project file, session file, comand"
-    "line options etc",
+    "with all the information you have: project file, session file, command "
+    "line options, etc.",
 
     /* XNEE_NO_REPLAY_DATA */   
     "record_replay structure missing",
     "This is a major error, please report the error "
-    "with all the information you have: project file, session file, comand"
-    "line options etc",
+    "with all the information you have: project file, session file, command "
+    "line options, etc.",
 
     /* XNEE_SYNTAX_ERROR */    
     "Xnee syntax error",
@@ -148,19 +148,19 @@
 
     /* XNEE_BAD_SESSION_FILE */   
     "Bad session file",
-    "Make sure that the path and permission to the session file are correct",
+    "Make sure that the path and permissions of the session file are correct",
 
     /* XNEE_BAD_SPEED */      
     "Invalid replay speed",
-    "Make sure that the replay speed is valid ",
+    "Make sure that the replay speed is valid",
 
     /* XNEE_BAD_RESOLUTION */ 
     "Invalid screen resolution",
-    "Make sure that the resolution is valid ",
+    "Make sure that the resolution is valid",
 
     /* XNEE_BAD_THRESHOLD */  
     "Invalid threshold(s)",
-    "Make sure that the threshold(s) is/are valid ",
+    "Make sure that the threshold(s) is/are valid",
 
     /* XNEE_BAD_CONTEXT */
     "Bad context",
@@ -219,7 +219,7 @@
     "No need to do anything",
 
     /* XNEE_GRAB_CONFUSION */            
-    "Xnee have reached a point where it is confused over the grabs done",
+    "Xnee has reached a point where it is confused over the grabs done",
     "Make sure you do not grab something already grabbed. If you are sure about this, report the problem (include recorded session file and verbose printout file)",
 
     /* XNEE_PROJECT_SYNTAX_ERROR */            
@@ -240,7 +240,7 @@
 
     /* XNEE_OVERRIDE_DISPLAY_FAILURE*/
     "Xnee failed to set the (user overridden) display to record",
-    "Report this bug together with the command line."
+    "Report this bug together with the command line.",
 
    /* XNEE_LAST_ERROR */
     "Last error",